import java.util.*

class ForthEvaluator {
    val stack: Stack<String> = Stack<String>()
    val overridenOperators = mutableMapOf<Char, Char>()

    private val validOps = listOf<String>("+", "-", "*", "/", "dup", "drop", "swap", "over")

    fun evaluateProgram(inpList: List<String>): List<Int>{
        for (i in inpList){
            val tokenized = i.split(' ')
            tokenized.all { validateToken(it) }
            for (j in tokenized){
                stack.push(j)
            }
        }
        return emptyList()
    }
    // TODO: This needs to actually work?
    private fun validateToken(token: String): Boolean {
        require(if (token.toInt() >= 0){ true } else token in validOps)
        return false
    }
}

fun main(args: Array<String>) {
    print(ForthEvaluator().evaluateProgram(listOf("1 2 3 4")))
}